#pragma once
#include <stdint.h>
#include <stdio.h>
#include <stdbool.h>
#include <malloc.h>

#define VK_USE_PLATFORM_WIN32_KHR
#define GLFW_INCLUDE_VULKAN
#include <GLFW/glfw3.h>
#include <cglm/call.h>

#define WINDOW_WIDTH 800
#define WINDOW_HEIGHT 600
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define DEV_QUEUE_COUNT 2

typedef struct {
  uint32_t graphicsFamily;
  bool graphicsFamilyFound;

  uint32_t presentFamily;
  bool presentFamilyFound;
} QueueFamilyIndices;

QueueFamilyIndices findQueueFamilies(VkPhysicalDevice device);

typedef struct {
  VkSurfaceCapabilitiesKHR capabilities;
  VkSurfaceFormatKHR *formats;
  VkPresentModeKHR *presentModes;

  VkSurfaceFormatKHR surfaceFormat;
  VkPresentModeKHR presentMode;
  VkExtent2D extent;
} SwapChainSupportDetails;

/**
 * Entry of the program
 * @return 0 if success, anything else for failure.
 */
int32_t main();
